typedef enum
{
	TOOL_GEM,
	TOOL_TARGET,
	TOOL_WALL,
	TOOL_BACKGROUND,
	TOOL_PLAYER
} ToolType;

struct _gui_elements {
  GtkWidget *gui_main;
  GtkWidget *tbbutton_clear;
  GtkWidget *tbbutton_modify;
  GtkWidget *tbbutton_solve;
  GtkWidget *notebook;
  GtkWidget *button_first;
  GtkWidget *button_back5;
  GtkWidget *button_back1;
  GtkWidget *button_forw1;
  GtkWidget *button_forw5;
  GtkWidget *button_last;
  GtkWidget *progressbar;
  GtkWidget *pixmap_table[ WIDTH ][ HEIGHT ];
};
extern struct _gui_elements Gui_Elements;

struct _gui_state {
  ToolType tool;
  gboolean tool_draws;
  gboolean tool_drawing;
  gint     index;
};
extern struct _gui_state Gui_State;


void gui_draw_down         (GtkWidget *eventbox,
                            GdkEventButton *event);
void gui_draw_enter        (GtkWidget *eventbox);
void gui_draw_up           (GtkWidget *eventbox);

void gui_tool_clicked      (GtkWidget *button,
                            gpointer   which_tool);

void gui_clear  (GtkWidget *);
void gui_modify (GtkWidget *);
void gui_solve  (GtkWidget *);
void gui_exit   (GtkWidget *);
void gui_about  (GtkWidget *);

void gui_first      (GtkWidget *);
void gui_backward5  (GtkWidget *);
void gui_backward   (GtkWidget *);
void gui_forward    (GtkWidget *);
void gui_forward5   (GtkWidget *);
void gui_last       (GtkWidget *);
