#include "sokodan.h"
#include <gtk/gtk.h>
#if USE_GNOME
# include <gnome.h>
#else
# define gnome_stock_pixmap_widget(arg1, arg2) NULL
#endif /* USE_GNOME */

#include "guix.h"
#include "pixmaps.h"
#include "gui.h"


struct _gui_elements Gui_Elements;
struct _gui_state    Gui_State;

void
gui_main_show (void)
{
  GtkWidget *gui_main;
  GtkWidget *vbox_window;
  GtkWidget *handlebox_tb;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *tbbutton_clear;
  GtkWidget *tbbutton_modify;
  GtkWidget *tbbutton_solve;
  GtkWidget *tbbutton_exit;
  GtkWidget *tbbutton_about;
  GtkWidget *frame_main;
  GtkWidget *vbox_main;
  GtkWidget *hbox_pb;
  GtkWidget *hseparator1;
  GtkWidget *label_pb;
  GtkWidget *hseparator2;
  GtkWidget *alignment;
  GtkWidget *frame_pb;
  GtkWidget *hbox_ctrl;
  GtkWidget *hseparator3;
  GtkWidget *label_ctrl;
  GtkWidget *hseparator4;
  GtkWidget *notebook;
  GtkWidget *hbuttonbox_tools;
  GtkWidget *button_gem;
  GtkWidget *pixmap_gem;
  GtkWidget *button_target;
  GtkWidget *pixmap_target;
  GtkWidget *button_wall;
  GtkWidget *pixmap_wall;
  GtkWidget *button_bg;
  GtkWidget *pixmap_bg;
  GtkWidget *button_player;
  GtkWidget *pixmap_player;
  GtkWidget *vbox_progress;
  GtkWidget *hbuttonbox_progress;
  GtkWidget *button_first;
  GtkWidget *pixmap_first;
  GtkWidget *button_back5;
  GtkWidget *pixmap_back5;
  GtkWidget *button_back1;
  GtkWidget *pixmap_back1;
  GtkWidget *button_forw1;
  GtkWidget *pixmap_forw1;
  GtkWidget *button_forw5;
  GtkWidget *pixmap_forw5;
  GtkWidget *button_last;
  GtkWidget *pixmap_last;
  GtkWidget *hbox_progress;
  GtkWidget *label_progress;
  GtkWidget *progressbar;
  GtkTooltips *tooltips;

  tooltips = gtk_tooltips_new ();

  gui_main = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (gui_main), PACKAGE " " VERSION);
  gtk_window_set_policy (GTK_WINDOW (gui_main), FALSE, TRUE, TRUE);

  vbox_window = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (gui_main), vbox_window);

  handlebox_tb = gtk_handle_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox_window), handlebox_tb, FALSE, FALSE, 0);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_container_add (GTK_CONTAINER (handlebox_tb), toolbar);
  gtk_toolbar_set_space_style (GTK_TOOLBAR (toolbar), GTK_TOOLBAR_SPACE_LINE);
  gtk_toolbar_set_button_relief (GTK_TOOLBAR (toolbar), GTK_RELIEF_NONE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (gui_main, GNOME_STOCK_PIXMAP_NEW);
  tbbutton_clear = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Nettoyer"),
                                _("Recommencer avec une grille vierge"), NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (gui_main, GNOME_STOCK_PIXMAP_PROPERTIES);
  tbbutton_modify = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Modifier"),
                                _("Reprendre l'dition du problme"), NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_set_sensitive (tbbutton_modify, FALSE);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (gui_main, GNOME_STOCK_PIXMAP_CONVERT);
  tbbutton_solve = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Rsoudre"),
                                _("Rsoudre le problme"), NULL,
                                tmp_toolbar_icon, NULL, NULL);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (gui_main, GNOME_STOCK_PIXMAP_EXIT);
  tbbutton_exit = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("Quitter"),
                                _("Quitter sokoDan"), NULL,
                                tmp_toolbar_icon, NULL, NULL);

  gtk_toolbar_append_space (GTK_TOOLBAR (toolbar));

  tmp_toolbar_icon = gnome_stock_pixmap_widget (gui_main, GNOME_STOCK_PIXMAP_ABOUT);
  tbbutton_about = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _(" propos"),
                                _(" propos de sokoDan"), NULL,
                                tmp_toolbar_icon, NULL, NULL);

  frame_main = gtk_frame_new (NULL);
  gtk_box_pack_start (GTK_BOX (vbox_window), frame_main, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (frame_main), 10);
  gtk_frame_set_shadow_type (GTK_FRAME (frame_main), GTK_SHADOW_NONE);

  vbox_main = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (frame_main), vbox_main);

  hbox_pb = gtk_hbox_new (FALSE, 10);
  gtk_box_pack_start (GTK_BOX (vbox_main), hbox_pb, FALSE, TRUE, 0);

  hseparator1 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox_pb), hseparator1, TRUE, TRUE, 0);

  label_pb = gtk_label_new (_("Problme"));
  gtk_box_pack_start (GTK_BOX (hbox_pb), label_pb, FALSE, FALSE, 0);

  hseparator2 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox_pb), hseparator2, TRUE, TRUE, 0);

  alignment = gtk_alignment_new (0.5, 0.5, 0, 0);
  gtk_box_pack_start (GTK_BOX (vbox_main), alignment, TRUE, TRUE, 0);

  frame_pb = gtk_frame_new (NULL);
  gtk_container_add (GTK_CONTAINER (alignment), frame_pb);
  gtk_frame_set_shadow_type (GTK_FRAME (frame_pb), GTK_SHADOW_IN);

  {
    GtkWidget *table;
    GtkWidget *eventbox;
    GtkWidget *pix_wid;
    gint x, y; /* "Should" be Coordinate, but then I would have to provide COORDINATE_TO_POINTER */
    
    table = gtk_table_new (HEIGHT, WIDTH, TRUE);
    gtk_container_add (GTK_CONTAINER (frame_pb), table);
    
    for (y = 0; y < HEIGHT; y++)
      for (x = 0; x < WIDTH; x++)
      {
        eventbox = gtk_event_box_new();
        gtk_table_attach (GTK_TABLE (table), eventbox,
                          x, x+1, y, y+1,
                          0, 0, 0, 0);

        pix_wid = gtk_pixmap_new (Case_Pixmap[ BACKGROUND ], NULL);
        gtk_container_add (GTK_CONTAINER (eventbox), pix_wid);

        gtk_object_set_data (GTK_OBJECT (pix_wid), "x", GINT_TO_POINTER(x));
        gtk_object_set_data (GTK_OBJECT (pix_wid), "y", GINT_TO_POINTER(y));
        gtk_object_set_data (GTK_OBJECT (pix_wid), "value", GINT_TO_POINTER(BACKGROUND));

        Gui_Elements.pixmap_table[ x ][ y ] = pix_wid;

        gtk_signal_connect (GTK_OBJECT (eventbox), "button_press_event",
                            GTK_SIGNAL_FUNC (gui_draw_down),  NULL);
        gtk_signal_connect (GTK_OBJECT (eventbox), "enter_notify_event",
                            GTK_SIGNAL_FUNC (gui_draw_enter), NULL);
        gtk_signal_connect (GTK_OBJECT (eventbox), "button_release_event",
                            GTK_SIGNAL_FUNC (gui_draw_up), NULL);
      }
  }
  
  hbox_ctrl = gtk_hbox_new (FALSE, 10);
  gtk_box_pack_start (GTK_BOX (vbox_main), hbox_ctrl, FALSE, TRUE, 0);

  hseparator3 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox_ctrl), hseparator3, TRUE, TRUE, 0);

  label_ctrl = gtk_label_new (_("Contrles"));
  gtk_box_pack_start (GTK_BOX (hbox_ctrl), label_ctrl, FALSE, FALSE, 0);

  hseparator4 = gtk_hseparator_new ();
  gtk_box_pack_start (GTK_BOX (hbox_ctrl), hseparator4, TRUE, TRUE, 0);

  notebook = gtk_notebook_new ();
  gtk_box_pack_start (GTK_BOX (vbox_main), notebook, FALSE, TRUE, 0);
  gtk_notebook_set_show_tabs (GTK_NOTEBOOK (notebook), FALSE);
  gtk_notebook_set_show_border (GTK_NOTEBOOK (notebook), FALSE);
  gtk_notebook_set_tab_hborder (GTK_NOTEBOOK (notebook), 0);
  gtk_notebook_set_tab_vborder (GTK_NOTEBOOK (notebook), 0);
  gtk_notebook_popup_enable (GTK_NOTEBOOK (notebook));

  hbuttonbox_tools = gtk_hbutton_box_new ();
  gtk_container_add (GTK_CONTAINER (notebook), hbuttonbox_tools);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox_tools), 10);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox_tools), 0, 0);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox_tools), 5, 5);

  button_gem = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_tools), button_gem);

  pixmap_gem = gtk_pixmap_new (Tool_Pixmap[ TOOL_GEM ], NULL);
  gtk_container_add (GTK_CONTAINER (button_gem), pixmap_gem);

  button_target = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_tools), button_target);

  pixmap_target = gtk_pixmap_new (Tool_Pixmap[ TOOL_TARGET ], NULL);
  gtk_container_add (GTK_CONTAINER (button_target), pixmap_target);

  button_wall = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_tools), button_wall);

  pixmap_wall = gtk_pixmap_new (Tool_Pixmap[ TOOL_WALL ], NULL);
  gtk_container_add (GTK_CONTAINER (button_wall), pixmap_wall);

  button_bg = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_tools), button_bg);

  pixmap_bg = gtk_pixmap_new (Tool_Pixmap[ TOOL_BACKGROUND ], NULL);
  gtk_container_add (GTK_CONTAINER (button_bg), pixmap_bg);

  button_player = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_tools), button_player);

  pixmap_player = gtk_pixmap_new (Tool_Pixmap[ TOOL_PLAYER ], NULL);
  gtk_container_add (GTK_CONTAINER (button_player), pixmap_player);

  vbox_progress = gtk_vbox_new (FALSE, 10);
  gtk_container_add (GTK_CONTAINER (notebook), vbox_progress);

  hbuttonbox_progress = gtk_hbutton_box_new ();
  gtk_box_pack_start (GTK_BOX (vbox_progress), hbuttonbox_progress, TRUE, TRUE, 0);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (hbuttonbox_progress), 10);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (hbuttonbox_progress), 0, 0);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (hbuttonbox_progress), 5, 5);

  button_first = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_first);
  gtk_tooltips_set_tip (tooltips, button_first, _("Revenir  la position initiale"), NULL);

  pixmap_first = gtk_pixmap_new (Control_Pixmap[ 0 ], Control_Mask[ 0 ]);
  gtk_container_add (GTK_CONTAINER (button_first), pixmap_first);

  button_back5 = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_back5);
  gtk_tooltips_set_tip (tooltips, button_back5, _("Revenir cinq coups en arrire"), NULL);

  pixmap_back5 = gtk_pixmap_new (Control_Pixmap[ 1 ], Control_Mask[ 1 ]);
  gtk_container_add (GTK_CONTAINER (button_back5), pixmap_back5);

  button_back1 = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_back1);
  gtk_tooltips_set_tip (tooltips, button_back1, _("Revenir un coup en arrire"), NULL);

  pixmap_back1 = gtk_pixmap_new (Control_Pixmap[ 2 ], Control_Mask[ 2 ]);
  gtk_container_add (GTK_CONTAINER (button_back1), pixmap_back1);

  button_forw1 = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_forw1);
  gtk_tooltips_set_tip (tooltips, button_forw1, _("Avancer d'un coup"), NULL);

  pixmap_forw1 = gtk_pixmap_new (Control_Pixmap[ 3 ], Control_Mask[ 3 ]);
  gtk_container_add (GTK_CONTAINER (button_forw1), pixmap_forw1);

  button_forw5 = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_forw5);
  gtk_tooltips_set_tip (tooltips, button_forw5, _("Avancer de cinq coups"), NULL);

  pixmap_forw5 = gtk_pixmap_new (Control_Pixmap[ 4 ], Control_Mask[ 4 ]);
  gtk_container_add (GTK_CONTAINER (button_forw5), pixmap_forw5);

  button_last = gtk_button_new ();
  gtk_container_add (GTK_CONTAINER (hbuttonbox_progress), button_last);
  gtk_tooltips_set_tip (tooltips, button_last, _("Avancer jusqu' la position finale"), NULL);

  pixmap_last = gtk_pixmap_new (Control_Pixmap[ 5 ], Control_Mask[ 5 ]);
  gtk_container_add (GTK_CONTAINER (button_last), pixmap_last);

  hbox_progress = gtk_hbox_new (FALSE, 0);
  gtk_box_pack_start (GTK_BOX (vbox_progress), hbox_progress, TRUE, TRUE, 0);

  label_progress = gtk_label_new (_("Avancement : "));
  gtk_box_pack_start (GTK_BOX (hbox_progress), label_progress, FALSE, FALSE, 0);

  progressbar = gtk_progress_bar_new ();
  gtk_box_pack_start (GTK_BOX (hbox_progress), progressbar, TRUE, TRUE, 0);
  gtk_progress_configure (GTK_PROGRESS (progressbar), 8, 0, 10);
  gtk_progress_set_show_text (GTK_PROGRESS (progressbar), TRUE);
  gtk_progress_set_format_string (GTK_PROGRESS (progressbar), "%V/%U");

  gtk_signal_connect (GTK_OBJECT (gui_main), "delete_event",
                      GTK_SIGNAL_FUNC (gui_exit),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tbbutton_clear), "clicked",
                      GTK_SIGNAL_FUNC (gui_clear),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tbbutton_modify), "clicked",
                      GTK_SIGNAL_FUNC (gui_modify),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tbbutton_solve), "clicked",
                      GTK_SIGNAL_FUNC (gui_solve),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tbbutton_exit), "clicked",
                      GTK_SIGNAL_FUNC (gui_exit),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tbbutton_about), "clicked",
                      GTK_SIGNAL_FUNC (gui_about),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_gem), "clicked",
                      GTK_SIGNAL_FUNC (gui_tool_clicked),
                      GINT_TO_POINTER (TOOL_GEM));

  gtk_signal_connect (GTK_OBJECT (button_target), "clicked",
                      GTK_SIGNAL_FUNC (gui_tool_clicked),
                      GINT_TO_POINTER (TOOL_TARGET));

  gtk_signal_connect (GTK_OBJECT (button_wall), "clicked",
                      GTK_SIGNAL_FUNC (gui_tool_clicked),
                      GINT_TO_POINTER (TOOL_WALL));

  gtk_signal_connect (GTK_OBJECT (button_bg), "clicked",
                      GTK_SIGNAL_FUNC (gui_tool_clicked),
                      GINT_TO_POINTER (TOOL_BACKGROUND));

  gtk_signal_connect (GTK_OBJECT (button_player), "clicked",
                      GTK_SIGNAL_FUNC (gui_tool_clicked),
                      GINT_TO_POINTER (TOOL_PLAYER));

  gtk_signal_connect (GTK_OBJECT (button_first), "clicked",
                      GTK_SIGNAL_FUNC (gui_first),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_back5), "clicked",
                      GTK_SIGNAL_FUNC (gui_backward5),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_back1), "clicked",
                      GTK_SIGNAL_FUNC (gui_backward),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_forw1), "clicked",
                      GTK_SIGNAL_FUNC (gui_forward),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_forw5), "clicked",
                      GTK_SIGNAL_FUNC (gui_forward5),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (button_last), "clicked",
                      GTK_SIGNAL_FUNC (gui_last),
                      NULL);

  Gui_Elements.gui_main        = gui_main;
  Gui_Elements.tbbutton_clear  = tbbutton_clear;
  Gui_Elements.tbbutton_modify = tbbutton_modify;
  Gui_Elements.tbbutton_solve  = tbbutton_solve;
  Gui_Elements.notebook        = notebook;
  Gui_Elements.button_first    = button_first;
  Gui_Elements.button_back5    = button_back5;
  Gui_Elements.button_back1    = button_back1;
  Gui_Elements.button_forw1    = button_forw1;
  Gui_Elements.button_forw5    = button_forw5;
  Gui_Elements.button_last     = button_last;
  Gui_Elements.progressbar     = progressbar;

  Gui_State.tool         = TOOL_GEM;
  Gui_State.tool_draws   = FALSE;
  Gui_State.tool_drawing = FALSE;
  Gui_State.index        = 0;

  gtk_widget_show_all (gui_main);
}


void gui_exit (GtkWidget *widget)
{
  gtk_exit (1);
}


void gui_about (GtkWidget *widget)
{
  gui_about_show ();
}
