#define SOLVE_UPDATE   1
#define SOLVE_SUCCESS  2
#define SOLVE_FAILURE  3
#define MAX_SOLVE_MSG_SIZE  40


static struct {
  GtkWidget *window;
  GtkWidget *button_abort;
  GtkWidget *button_solved;
  GtkWidget *button_failed;

	gint       update_period;
  GtkWidget *label_time;
  time_t     start_time;
  GtkWidget *label_depth;
  GtkWidget *progressbar;
  GtkWidget *label_count;

  pthread_t  solve_thr;
  gint       solve_output_tag;
} progress_data = { 
  NULL, NULL, NULL, NULL,
  100, NULL, 0, NULL, NULL, NULL,
  0, 0
}; /* maybe we should correctly initialize this struct (memset ( , 0, )) */


/* solve, with a nice prototype for pthread_create */
void *psolve (void *); /* in solve.c */

static void gui_progress_dialog_show (void);

static void update_progress_data (int depth, 
                                  int nb_of_studied_positions_in_this_level,
                                  int nb_of_positions_in_this_level,
                                  int nb_of_studied_positions);
static void handle_solve_output (gpointer          data,
                                 gint              source,
                                 GdkInputCondition condition);
static int changed_update_rhythm (GtkWidget *optionmenu,
																	gpointer  _new_period);

static int close_progress_dlg                   (GtkWidget *unused);
static int close_progress_dlg_and_show_solution (GtkWidget *unused);
static int abort_solve                          (GtkWidget *unused);
