#include "sokodan.h"
#include <gtk/gtk.h>
/* #include "PositionX.h" */
#include "pixmaps.h"
#include "guix.h"
#include "gui.h"


static void display_position (void);

void gui_first (GtkWidget *button)
{
  Gui_State.index = 0;
  display_position ();
}

void gui_backward5 (GtkWidget *button)
{
  Gui_State.index = MAX (0, Gui_State.index - 5);
  display_position ();
}

void gui_backward (GtkWidget *button)
{
  Gui_State.index = MAX (0, Gui_State.index - 1);
  display_position ();
}

void gui_forward (GtkWidget *button)
{
  Gui_State.index = MIN (Solution.length - 1, Gui_State.index + 1);
  display_position ();
}

void gui_forward5 (GtkWidget *button)
{
  Gui_State.index = MIN (Solution.length - 1, Gui_State.index + 5);
  display_position ();
}

void gui_last (GtkWidget *button)
{
  Gui_State.index = Solution.length - 1;
  display_position ();
}

void gui_modify (GtkWidget *button)
{
  /* Go back to the first position */
  Gui_State.index = 0;
  display_position ();

  /* Free the solution */
  g_free (Solution.position);
  Solution.position = NULL;
  Solution.length = 0;
  
  /* Reset the Problem gui */
  gtk_widget_set_sensitive (Gui_Elements.tbbutton_clear, TRUE);
  gtk_widget_set_sensitive (Gui_Elements.tbbutton_modify, FALSE);
  gtk_widget_set_sensitive (Gui_Elements.tbbutton_solve, TRUE);

  gtk_notebook_prev_page (GTK_NOTEBOOK (Gui_Elements.notebook));

  {
    Coordinate x, y;
    GtkWidget *eventbox;
    
    for (y = 0; y < HEIGHT; y++)
      for (x = 0; x < WIDTH; x++)
      {
        eventbox = Gui_Elements.pixmap_table[ x ][ y ]->parent;
          
        gtk_signal_handler_unblock_by_func (GTK_OBJECT (eventbox), GTK_SIGNAL_FUNC (gui_draw_down),  NULL);
        gtk_signal_handler_unblock_by_func (GTK_OBJECT (eventbox), GTK_SIGNAL_FUNC (gui_draw_up),  NULL);
        gtk_signal_handler_unblock_by_func (GTK_OBJECT (eventbox), GTK_SIGNAL_FUNC (gui_draw_enter),  NULL);
      }
  }
}

static void
display_position (void)
{
  gint       pix_index;  /* index of the pixmap in case_pixmaps */
  Coordinate x, y;   /* Current case */
  Coordinate px, py; /* Where the player is */
  GtkWidget *pix_wid;
  gint       index;

  index = Gui_State.index;
  g_assert (index >= 0);
  g_assert (index < Solution.length);

  px = Solution.position[ index ].player_x;
  py = Solution.position[ index ].player_y;

  for (y = 0; y < HEIGHT; y++)
    for (x = 0; x < WIDTH; x++)
    {
      /* table -> pix_wid */
      pix_index = Solution.position[ index ].grid[ x ][ y ];
      REMOVE (ACCESSIBLE, pix_index);
      pix_index += (x == px && y == py) ? 1 : 0;

      pix_wid = Gui_Elements.pixmap_table[ x ][ y ];

      if (pix_index !=
          GPOINTER_TO_INT (gtk_object_get_data (GTK_OBJECT (pix_wid), "value")))
      {
        g_assert (Case_Pixmap[ pix_index ] != NULL);
        gtk_pixmap_set (GTK_PIXMAP (pix_wid), Case_Pixmap[ pix_index ], NULL);

        gtk_object_set_data (GTK_OBJECT (pix_wid), 
                             "value", GINT_TO_POINTER (pix_index));
      }
    }

  gtk_progress_set_value (GTK_PROGRESS (Gui_Elements.progressbar), index);

  gtk_widget_set_sensitive (Gui_Elements.button_first, index == 0 ? FALSE : TRUE);
  gtk_widget_set_sensitive (Gui_Elements.button_back5, index == 0 ? FALSE : TRUE);
  gtk_widget_set_sensitive (Gui_Elements.button_back1, index == 0 ? FALSE : TRUE);
  gtk_widget_set_sensitive (Gui_Elements.button_forw1, index == Solution.length-1 ? FALSE : TRUE);
  gtk_widget_set_sensitive (Gui_Elements.button_forw5, index == Solution.length-1 ? FALSE : TRUE);
  gtk_widget_set_sensitive (Gui_Elements.button_last,  index == Solution.length-1 ? FALSE : TRUE);
}
